Subject: Re: [RFC][PATCH 1/1] cxgb3i: cxgb3 iSCSI initiator

From: Tom Tucker <[email-masked]>
Date: Wed, 13 Aug 2008 20:26:51 -0500

David Miller wrote:
> From: Roland Dreier <[email-masked]>
> Date: Wed, 13 Aug 2008 16:03:15 -0700
>
>   
>> OK, I admit you could make something work -- add hooks for the low-level
>> driver to ask the iSCSI initiator where PDU boundaries are so it can
>> resync when something is evicted from the flow cache, have the initiator
>> format its tags in a special way to encode placement data, etc, etc.
>> The scheme does bring to mind Alan's earlier comment about pigs and
>> propulsion, though.
>>     
>
> There would need to be _NO_ hooks into the iSCSI initiator at all.
>
> The card would land the block I/O data onto the necessary page boundaries
> and the iSCSI code would just be able to thus use the pages directly
> and as-is.
>
> It would look perfectly like normal TCP receive traffic.  No hooks,
> no special cases, nothing like that.
>
>   
>> In any case, as I said in the part of my email that you snipped, the
>> real issue is not designing hypothetical hardware, but deciding how to
>> support the Chelsio, Broadcom, etc hardware that exists today.
>>     
>
> The same like we support TOE hardware that exists today.  That is, we
> don't.
>
>   
Is there any chance your could discuss exactly how a stateless adapter 
can determine if a network segment
is in-order, next expected, minus productive ack, paws compliant, etc... 
without TCP state?

I get how you can optimize "flows", but "flows" are a fancy name for a 
key (typically the four-tuple) that looks into a TCAM  to get the 
"information" necessary to do header prediction.

Can you explain how this "information" somehow doesn't qualify as 
"state". Doesn't the next expected sequence number at the very least 
need to be updated? una? etc...?

Could you also include the "non-state-full" information necessary to do 
iSCSI header digest validation, data placement, and marker removal? 

Thanks,
Tom
> --
> To unsubscribe from this list: send the line "unsubscribe netdev" in
> the body of a message to [email-masked]
> More majordomo info at  http://vger.kernel.org/majordomo-info.html
>